/*======================================================================*\
|*		Editor mined						*|
|*		MSDOS mouse functions					*|
|*		currently included from io.c				*|
\*======================================================================*/

#ifdef __TURBOC__
#undef dpmi_call
#endif

#ifdef dpmi_call
#include <dpmi.h>
#endif

extern void mouseinit __((void));
extern void hidemouse __((void));
extern void mousestat __((void));
extern int mousegetch __((void));


/*======================================================================*\
|*		mouse functions and data				*|
\*======================================================================*/

#ifdef dpmi_call
__dpmi_regs mregs;
#else
union REGS mregs;
#endif


static
void mousecall ()
{
	mregs.x.bx = 0;
#ifdef dpmi_call
	__dpmi_int (0x33, & mregs);
#else
	int86 (0x33, & mregs, & mregs);
#endif
}

void mouseinit ()
{
	mregs.x.ax = 0;
	mousecall ();
}

static
void showmouse ()
{
	mregs.x.ax = 1;
	mousecall ();
}

void hidemouse ()
{
	mregs.x.ax = 2;
	mousecall ();
}

void mousestat ()
{
	mregs.x.ax = 3;
	mousecall ();
}

int mousegetch ()
{
	int result;

	showmouse ();
	mregs.x.bx = 0;
	mousestat ();
	while (mregs.x.bx) {
		mousestat ();
	}
/*	while ((! bioskey (1)) && (! mregs.x.bx)) {*/
	while ((! kbhit ()) && (! mregs.x.bx)) {
		mousestat ();
	}
	if (mregs.x.bx) {
	/*	bx: button - 1 = left, 2 = right, 4 = middle
		cx: column * 8 (first is 0)
		dx: line * 8 (first is 0)
	*/
		result = mregs.x.bx;
		hidemouse ();
		return - result;
	} else {
		hidemouse ();
		result = getch ();
		return result;
	}
}


static
void
DIRECTdosmousegetxy ()
{
  mouse_lastbutton = mouse_button;
  if (mouse_button == leftbutton || mouse_button == rightbutton || mouse_button == middlebutton) {
	mouse_prevbutton = mouse_button;
  }
  mouse_lastxpos = mouse_xpos;
  mouse_lastypos = mouse_ypos;

  mousestat ();

  if (mregs.x.bx == 1) {
	mouse_button = leftbutton;
  } else if (mregs.x.bx == 4) {
	mouse_button = middlebutton;
  } else if (mregs.x.bx == 2) {
	mouse_button = rightbutton;
  } else {
	mouse_button = releasebutton;
  }

  /*
	mouse_xpos: column (first is 0)
	mouse_ypos: line after menu (first is 0, menu line is -1)
  */
  mouse_ypos = (mregs.x.dx >> 3) - MENU;
  mouse_xpos = mregs.x.cx >> 3;
}


/*======================================================================*\
|*				End					*|
\*======================================================================*/
