/*======================================================================*\
|*		Editor mined						*|
|*		keyboard transformation					*|
|*		for international keyboard mappings			*|
|*		included from keyboard.c				*|
\*======================================================================*/


struct keymap keymap_arabic [] = {
	{"q", "ض"},	/* (1590)        - DAD */
	{"w", "ص"},	/* (1589)        - SAD */
	{"e", "ث"},	/* (1579)        - THEH */
	{"r", "ق"},	/* (1602)        - QAF */
	{"t", "ف"},	/* (1601)        - FEH */
	{"y", "غ"},	/* (1594)        - GHAIN */
	{"u", "ع"},	/* (1593)        - AIN */
	{"i", "ه"},	/* (1607)        - HEH */
	{"o", "خ"},	/* (1582)        - KHAH */
	{"p", "ح"},	/* (1581)        - HAH */
	{"[", "ج"},	/* (1580)        - JEEM */
	{"]", "د"},	/* (1583)        - DAL */
	{"a", "ش"},	/* (1588)        - SHEEN */
	{"s", "س"},	/* (1587)        - SEEN */
	{"d", "ي"},	/* (1610)        - YEH */
	{"f", "ب"},	/* (1576)        - BEH */
	{"g", "ل"},	/* (1604)        - LAM */
	{"h", "ا"},	/* (1575)        - ALEF */
	{"j", "ت"},	/* (1578)        - TEH */
	{"k", "ن"},	/* (1606)        - NOON */
	{"l", "م"},	/* (1605)        - MEEM */
	{";", "ك"},	/* (1603)        - KAF */
	{"'", "ط"},	/* (1591)        - TAH */
	{"z", "ئ"},	/* (1574)        - YEH with HAMZA ABOVE */
	{"x", "ء"},	/* (1569)        - HAMZA */
	{"c", "ؤ"},	/* (1572)        - WAW with HAMZA ABOVE */
	{"v", "ر"},	/* (1585)        - REH */
	{"b", "لا"},	/* (1604/1575)   - LAA (lam alef) */
	{"n", "ى"},	/* (1609)        - ALEF MAKSURA */
	{"m", "ة"},	/* (1577)        - TEH MARBUTA */
	{",", "و"},	/* (1608)        - WAW */
	{".", "ز"},	/* (1586)        - ZAIN */
	{"/", "ظ"},	/* (1592)        - ZAH */
	{"0", "٠"},	/* (1632)        - Arabic 0 */
	{"1", "١"},	/* (1633)        - Arabic 1 */
	{"2", "٢"},	/* (1634)        - Arabic 2 */
	{"3", "٣"},	/* (1635)        - Arabic 3 */
	{"4", "٤"},	/* (1636)        - Arabic 4 */
	{"5", "٥"},	/* (1637)        - Arabic 5 */
	{"6", "٦"},	/* (1638)        - Arabic 6 */
	{"7", "٧"},	/* (1639)        - Arabic 7 */
	{"8", "٨"},	/* (1640)        - Arabic 8 */
	{"9", "٩"},	/* (1641)        - Arabic 9 */
	{"`", "ذ"},	/* (1584)        - THAL */
	{"~", "ّ"},	/* (1617)        - Harakat -- SHADDA */
	{"Q", "َ"},	/* (1614)        - Harakat -- FATHA */
	{"W", "ً"},	/* (1611)        - Tanween -- FATHATAN */
	{"E", "ُ"},	/* (1615)        - Harakat -- DAMMA */
	{"R", "ٌ"},	/* (1612)        - Tanween -- DAMMATAN */
	{"T", "لإ"},	/* (1604/1573)   - LAA  with HAMZA BELOW */
	{"Y", "إ"},	/* (1573)        - ALEF with HAMZA BELOW */
	{"U", "`"},	/* (96)          - ASCII -- ` */
	{"P", "؛"},	/* (1563)        - Arabic Semicolon */
	{"{", "<"},	/* (60)          - ASCII -- < */
	{"}", ">"},	/* (62)          - ASCII -- > */
	{"A", "ِ"},	/* (1616)        - Harakat -- KASRA */
	{"S", "ٍ"},	/* (1613)        - Tanween -- KASRATAN */
	{"D", "["},	/* (91)          - ASCII -- [ */
	{"F", "]"},	/* (93)          - ASCII -- ] */
	{"G", "لأ"},	/* (1604/1571)   - LAA  with HAMZA ABOVE */
	{"H", "أ"},	/* (1571)        - ALEF with HAMZA ABOVE */
	{"J", "ـ"},	/* (1600)        - TATWEEL */
	{"K", "،"},	/* (1548)        - Arabic Comma */
	{"L", "/"},	/* (47)          - ASCII -- / */
	{"Z", "~"},	/* (126)         - ASCII -- ~ */
	{"X", "ْ"},	/* (1618)        - Harakat -- SUKUN */
	{"C", "{"},	/* (123)         - ASCII -- { */
	{"V", "}"},	/* (125)         - ASCII -- } */
	{"B", "لآ"},	/* (1604/1570)   - LAA  with MADDA ABOVE */
	{"N", "آ"},	/* (1570)        - ALEF with MADDA ABOVE */
	{"M", "'"},	/* (39)          - ASCII -- ' */
	{"<", ","},	/* (44)          - ASCII -- , */
	{">", "."},	/* (46)          - ASCII -- . */
	{"?", "؟"},	/* (1567)        - Arabic Question Mark */
	{NIL_PTR}
};

struct keymap keymap_GreekMonotonic [] = {
	{"E$", "€"},	/* EURO SIGN */
	{">>", "»"},	/* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK [GREEK EISAGOGIKA/OMOIOMATIKA - DEFINITION MISSING FROM UNICODE] */
	{"<<", "«"},	/* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK [GREEK EISAGOGIKA - DEFINITION MISSING FROM UNICODE] */
	{"Q", ":"},	/* COLON [GREEK EPEXIGIMATIKA OR ANO & KATO TELEIA - DEFINITION MISSING FROM UNICODE] */
	{"q", ";"},	/* GREEK QUESTION MARK (EROTIMATIKO) */
	{";.", "·"},	/* GREEK ANO TELEIA */
	{"W", "·"},	/* GREEK ANO TELEIA */
	{":", "¨"},	/* DIAERESIS [GREEK DIALYTIKA - DEFINITION MISSING FROM UNICODE] */
	{";", "΄"},	/* GREEK TONOS */
	{":;", "΅"},	/* GREEK DIALYTIKA TONOS */
	{";:", "΅"},	/* GREEK DIALYTIKA TONOS */
	{"A", "Α"},	/* GREEK CAPITAL LETTER ALPHA */
	{"B", "Β"},	/* GREEK CAPITAL LETTER BETA */
	{"G", "Γ"},	/* GREEK CAPITAL LETTER GAMMA */
	{"D", "Δ"},	/* GREEK CAPITAL LETTER DELTA */
	{"E", "Ε"},	/* GREEK CAPITAL LETTER EPSILON */
	{"Z", "Ζ"},	/* GREEK CAPITAL LETTER ZETA */
	{"H", "Η"},	/* GREEK CAPITAL LETTER ETA */
	{"U", "Θ"},	/* GREEK CAPITAL LETTER THETA */
	{"I", "Ι"},	/* GREEK CAPITAL LETTER IOTA */
	{"K", "Κ"},	/* GREEK CAPITAL LETTER KAPPA */
	{"L", "Λ"},	/* GREEK CAPITAL LETTER LAMDA */
	{"M", "Μ"},	/* GREEK CAPITAL LETTER MU */
	{"N", "Ν"},	/* GREEK CAPITAL LETTER NU */
	{"J", "Ξ"},	/* GREEK CAPITAL LETTER XI */
	{"O", "Ο"},	/* GREEK CAPITAL LETTER OMIKRON */
	{"P", "Π"},	/* GREEK CAPITAL LETTER PI */
	{"R", "Ρ"},	/* GREEK CAPITAL LETTER RHO */
	{"S", "Σ"},	/* GREEK CAPITAL LETTER SIGMA */
	{"T", "Τ"},	/* GREEK CAPITAL LETTER TAU */
	{"Y", "Υ"},	/* GREEK CAPITAL LETTER UPSILON */
	{"F", "Φ"},	/* GREEK CAPITAL LETTER PHI */
	{"X", "Χ"},	/* GREEK CAPITAL LETTER CHI */
	{"C", "Ψ"},	/* GREEK CAPITAL LETTER PSI */
	{"V", "Ω"},	/* GREEK CAPITAL LETTER OMEGA */
	{"a", "α"},	/* GREEK SMALL LETTER ALPHA */
	{"b", "β"},	/* GREEK SMALL LETTER BETA */
	{"g", "γ"},	/* GREEK SMALL LETTER GAMMA */
	{"d", "δ"},	/* GREEK SMALL LETTER DELTA */
	{"e", "ε"},	/* GREEK SMALL LETTER EPSILON */
	{"z", "ζ"},	/* GREEK SMALL LETTER ZETA */
	{"h", "η"},	/* GREEK SMALL LETTER ETA */
	{"u", "θ"},	/* GREEK SMALL LETTER THETA */
	{"i", "ι"},	/* GREEK SMALL LETTER IOTA */
	{"k", "κ"},	/* GREEK SMALL LETTER KAPPA */
	{"l", "λ"},	/* GREEK SMALL LETTER LAMDA */
	{"m", "μ"},	/* GREEK SMALL LETTER MU */
	{"n", "ν"},	/* GREEK SMALL LETTER NU */
	{"j", "ξ"},	/* GREEK SMALL LETTER XI */
	{"o", "ο"},	/* GREEK SMALL LETTER OMICRON */
	{"p", "π"},	/* GREEK SMALL LETTER PI */
	{"r", "ρ"},	/* GREEK SMALL LETTER RHO */
	{"w", "ς"},	/* GREEK SMALL LETTER FINAL SIGMA */
	{"s", "σ"},	/* GREEK SMALL LETTER SIGMA */
	{"t", "τ"},	/* GREEK SMALL LETTER TAU */
	{"y", "υ"},	/* GREEK SMALL LETTER UPSILON */
	{"f", "φ"},	/* GREEK SMALL LETTER PHI */
	{"x", "χ"},	/* GREEK SMALL LETTER CHI */
	{"c", "ψ"},	/* GREEK SMALL LETTER PSI */
	{"v", "ω"},	/* GREEK SMALL LETTER OMEGA */
	{";A", "Ά"},	/* GREEK CAPITAL LETTER ALPHA WITH TONOS */
	{";E", "Έ"},	/* GREEK CAPITAL LETTER EPSILON WITH TONOS */
	{";H", "Ή"},	/* GREEK CAPITAL LETTER ETA WITH TONOS */
	{";I", "Ί"},	/* GREEK CAPITAL LETTER IOTA WITH TONOS */
	{";O", "Ό"},	/* GREEK CAPITAL LETTER OMICRON WITH TONOS */
	{";Y", "Ύ"},	/* GREEK CAPITAL LETTER UPSILON WITH TONOS */
	{";V", "Ώ"},	/* GREEK CAPITAL LETTER OMEGA WITH TONOS */
	{":;i", "ΐ"},	/* GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS */
	{";:i", "ΐ"},	/* GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS */
	{":I", "Ϊ"},	/* GREEK CAPITAL LETTER IOTA WITH DIALYTIKA */
	{":Y", "Ϋ"},	/* GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA */
	{";a", "ά"},	/* GREEK SMALL LETTER ALPHA WITH TONOS */
	{";e", "έ"},	/* GREEK SMALL LETTER EPSILON WITH TONOS */
	{";h", "ή"},	/* GREEK SMALL LETTER ETA WITH TONOS */
	{";i", "ί"},	/* GREEK SMALL LETTER IOTA WITH TONOS */
	{":;y", "ΰ"},	/* GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS */
	{";:y", "ΰ"},	/* GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS */
	{":i", "ϊ"},	/* GREEK SMALL LETTER IOTA WITH DIALYTIKA */
	{":y", "ϋ"},	/* GREEK SMALL LETTER UPSILON WITH DIALYTIKA */
	{";o", "ό"},	/* GREEK SMALL LETTER OMICRON WITH TONOS */
	{";y", "ύ"},	/* GREEK SMALL LETTER UPSILON WITH TONOS */
	{";v", "ώ"},	/* GREEK SMALL LETTER OMEGA WITH TONOS */
	{";#", "ʹ"},	/* GREEK NUMERAL SIGN */
	{";##", "͵"},	/* GREEK LOWER NUMERAL SIGN */
	{";b", "ϐ"},	/* GREEK BETA SYMBOL */
	{";u", "ϑ"},	/* GREEK THETA SYMBOL */
	{";f", "ϕ"},	/* GREEK PHI SYMBOL */
	{";p", "ϖ"},	/* GREEK PI SYMBOL */
	{"#st", "Ϛ"},	/* GREEK LETTER STIGMA */
	{"#g", "Ϝ"},	/* GREEK LETTER DIGAMMA */
	{"#q", "Ϟ"},	/* GREEK LETTER KOPPA */
	{"#sp", "Ϡ"},	/* GREEK LETTER SAMPI */
	{";k", "ϰ"},	/* GREEK KAPPA SYMBOL */
	{";r", "ϱ"},	/* GREEK RHO SYMBOL */
	{";c", "ϲ"},	/* GREEK LUNATE SIGMA SYMBOL */
	{";.", "·"},	/* GREEK ANO TELEIA (KDE/kikbd/Xinput standard) */
	{"W", "·"},	/* GREEK ANO TELEIA (Emacs standard) */
	{"'", "᾽"},	/* GREEK APOSTROFOS */
	{"--", "–"},	/* endash */
	{"---", "—"},	/* emdash */
	{";>", "»"},	/*  */
	{";<", "«"},	/* */
	{"&&", "ϗ"},	/* Greek kai */
	{"D$", "₯"},	/* Drachma symbol */
	{NIL_PTR}
};

struct keymap keymap_Hebrew [] = {
	{"a", "אַ"},	/* HEBREW LETTER ALEF, HEBREW POINT PATAH */
	{"A", "א"},	/* HEBREW LETTER ALEF */
	{"B", "בֿ"},	/* HEBREW LETTER BET, HEBREW POINT RAFE */
	{"b", "ב"},	/* HEBREW LETTER BET */
	{"c", "צ"},	/* HEBREW LETTER TSADI */
	{"C", "ץ"},	/* HEBREW LETTER FINAL TSADI */
	{"d", "ד"},	/* HEBREW LETTER DALET */
	{"e", "ע"},	/* HEBREW LETTER AYIN */
	{"E", "ײ"},	/* HEBREW LIGATURE YIDDISH DOUBLE YOD */
	{"f", "פֿ"},	/* HEBREW LETTER PE, HEBREW POINT RAFE */
	{"F", "ף"},	/* HEBREW LETTER FINAL PE */
	{"g", "ג"},	/* HEBREW LETTER GIMEL */
	{"h", "ה"},	/* HEBREW LETTER HE */
	{"H", "ח"},	/* HEBREW LETTER HET */
	{"i", "י"},	/* HEBREW LETTER YOD */
	{"I", "יִ"},	/* HEBREW LETTER YOD, HEBREW POINT HIRIQ */
	{"j", "ײ"},	/* HEBREW LIGATURE YIDDISH DOUBLE YOD */
	{"J", "ײַ"},	/* HEBREW LIGATURE YIDDISH DOUBLE YOD, HEBREW POINT PATAH */
	{"k", "ק"},	/* HEBREW LETTER QOF */
	{"K", "כּ"},	/* HEBREW LETTER KAF, HEBREW POINT DAGESH OR MAPIQ */
	{"l", "ל"},	/* HEBREW LETTER LAMED */
	{"m", "מ"},	/* HEBREW LETTER MEM */
	{"M", "ם"},	/* HEBREW LETTER FINAL MEM */
	{"n", "נ"},	/* HEBREW LETTER NUN */
	{"N", "ן"},	/* HEBREW LETTER FINAL NUN */
	{"o", "אָ"},	/* HEBREW LETTER ALEF, HEBREW POINT QAMATS */
	{"O", "ױ"},	/* HEBREW LIGATURE YIDDISH VAV YOD */
	{"p", "פּ"},	/* HEBREW LETTER PE, HEBREW POINT DAGESH OR MAPIQ */
	{"q", "ײַ"},	/* HEBREW LIGATURE YIDDISH DOUBLE YOD, HEBREW POINT PATAH */
	{"r", "ר"},	/* HEBREW LETTER RESH */
	{"s", "ס"},	/* HEBREW LETTER SAMEKH */
	{"S", "ת"},	/* HEBREW LETTER TAV */
	{"t", "ט"},	/* HEBREW LETTER TET */
	{"T", "תּ"},	/* HEBREW LETTER TAV, HEBREW POINT DAGESH OR MAPIQ */
	{"u", "ו"},	/* HEBREW LETTER VAV */
	{"U", "וּ"},	/* HEBREW LETTER VAV, HEBREW POINT DAGESH OR MAPIQ */
	{"v", "װ"},	/* HEBREW LIGATURE YIDDISH DOUBLE VAV */
	{"V", "בֿ"},	/* HEBREW LETTER BET, HEBREW POINT RAFE */
	{"w", "ש"},	/* HEBREW LETTER SHIN */
	{"W", "שׂ"},	/* HEBREW LETTER SHIN, HEBREW POINT SIN DOT */
	{"x", "כ"},	/* HEBREW LETTER KAF */
	{"X", "ך"},	/* HEBREW LETTER FINAL KAF */
	{"y", "י"},	/* HEBREW LETTER YOD */
	{"Y", "ײַ"},	/* HEBREW LIGATURE YIDDISH DOUBLE YOD, HEBREW POINT PATAH  */
	{"z", "ז"},	/* HEBREW LETTER ZAYIN */
	{NIL_PTR}
};

struct keymap keymap_Cyrillic [] = {
	{"<<", "«"},	/* « = LEFT-POINTING DOUBLE ANGLE QUOTATION MARK = <Q> */
	{">>", "»"},	/* » = RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK = </Q> */
	{",,", "„"},	/* „ = DOUBLE LOW-9 QUOTATION MARK = <Q> */
	{"``", "“"},	/* “ = LEFT DOUBLE QUOTATION MARK = </Q> */
	{"N.", "№"},	/* № = NUMERO SIGN */
	{"C)", "©"},	/* © = COPYRIGHT SIGN */
	{"x)", "•"},	/* • = BULLET */
	{":)", "☺"},	/* ☺ = WHITE SMILING FACE */
	{":(", "☹"},	/* ☹ = WHITE FROWNING FACE */
	{"C-", "¤"},	/* ¤ = CURRENCY SIGN */
	{"E-", "€"},	/* € = EURO SIGN */
	{"L-", "£"},	/* £ = POUND SIGN */
	{"A", "А"},	/* А = CYRILLIC CAPITAL LETTER A  */
	{"B", "Б"},	/* Б = CYRILLIC CAPITAL LETTER BE */
	{"V", "В"},	/* В = CYRILLIC CAPITAL LETTER VE */
	{"G", "Г"},	/* Г = CYRILLIC CAPITAL LETTER GHE */
	{"D", "Д"},	/* Д = CYRILLIC CAPITAL LETTER DE */
	{"D-", "Ђ"},	/* Ђ = CYRILLIC CAPITAL LETTER DJE */
	{"G'", "Ѓ"},	/* Ѓ = CYRILLIC CAPITAL LETTER GJE */
	{"E", "Е"},	/* Е = CYRILLIC CAPITAL LETTER IE */
	{"E:", "Ё"},	/* Ё = CYRILLIC CAPITAL LETTER IO  */
	{"E>", "Є"},	/* Є = CYRILLIC CAPITAL LETTER UKRAINIAN IE */
	{"Z<", "Ж"},	/* Ж = CYRILLIC CAPITAL LETTER ZHE */
	{"Z", "З"},	/* З = CYRILLIC CAPITAL LETTER ZE */
	{"Z>", "Ѕ"},	/* Ѕ = CYRILLIC CAPITAL LETTER DZE */
	{"I", "И"},	/* И = CYRILLIC CAPITAL LETTER I */
	{"I`", "І"},	/* І = CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I */
	{"I:", "Ї"},	/* Ї = CYRILLIC CAPITAL LETTER YI */
	{"J<", "Ј"},	/* Ј = CYRILLIC CAPITAL LETTER JE */
	{"J", "Й"},	/* Й = CYRILLIC CAPITAL LETTER SHORT I */
	{"K", "К"},	/* К = CYRILLIC CAPITAL LETTER KA */
	{"L", "Л"},	/* Л = CYRILLIC CAPITAL LETTER EL */
	{"L>", "Љ"},	/* Љ = CYRILLIC CAPITAL LETTER LJE */
	{"M", "М"},	/* М = CYRILLIC CAPITAL LETTER EM */
	{"N", "Н"},	/* Н = CYRILLIC CAPITAL LETTER EN */
	{"N>", "Њ"},	/* Њ = CYRILLIC CAPITAL LETTER NJE */
	{"O", "О"},	/* О = CYRILLIC CAPITAL LETTER O */
	{"P", "П"},	/* П = CYRILLIC CAPITAL LETTER PE */
	{"R", "Р"},	/* Р = CYRILLIC CAPITAL LETTER ER */
	{"S", "С"},	/* С = CYRILLIC CAPITAL LETTER ES */
	{"T", "Т"},	/* Т = CYRILLIC CAPITAL LETTER TE */
	{"C'", "Ћ"},	/* Ћ = CYRILLIC CAPITAL LETTER TSHE */
	{"K'", "Ќ"},	/* Ќ = CYRILLIC CAPITAL LETTER KJE */
	{"U", "У"},	/* У = CYRILLIC CAPITAL LETTER U */
	{"U<", "Ў"},	/* Ў = CYRILLIC CAPITAL LETTER SHORT U */
	{"F", "Ф"},	/* Ф = CYRILLIC CAPITAL LETTER EF */
	{"H", "Х"},	/* Х = CYRILLIC CAPITAL LETTER HA */
	{"C", "Ц"},	/* Ц = CYRILLIC CAPITAL LETTER TSE */
	{"C<", "Ч"},	/* Ч = CYRILLIC CAPITAL LETTER CHE */
	{"D>", "Џ"},	/* Џ = CYRILLIC CAPITAL LETTER DZHE */
	{"S<", "Ш"},	/* Ш = CYRILLIC CAPITAL LETTER SHA */
	{"S>", "Щ"},	/* Щ = CYRILLIC CAPITAL LETTER SHCHA */
	{"\"\"", "Ъ"},	/* Ъ = CYRILLIC CAPITAL LETTER HARD SIGN */
	{"Y", "Ы"},	/* Ы = CYRILLIC CAPITAL LETTER YERU */
	{"\"", "Ь"},	/* Ь = CYRILLIC CAPITAL LETTER SOFT SIGN */
	{"E`", "Э"},	/* Э = CYRILLIC CAPITAL LETTER E */
	{"U>", "Ю"},	/* Ю = CYRILLIC CAPITAL LETTER YU */
	{"A>", "Я"},	/* Я = CYRILLIC CAPITAL LETTER YA */
	{"a", "а"},	/* а = CYRILLIC SMALL LETTER A */
	{"b", "б"},	/* б = CYRILLIC SMALL LETTER BE */
	{"v", "в"},	/* в = CYRILLIC SMALL LETTER VE */
	{"g", "г"},	/* г = CYRILLIC SMALL LETTER GHE */
	{"d", "д"},	/* д = CYRILLIC SMALL LETTER DE */
	{"d-", "ђ"},	/* ђ = CYRILLIC SMALL LETTER DJE */
	{"g'", "ѓ"},	/* г = CYRILLIC SMALL LETTER GJE */
	{"e", "е"},	/* е = CYRILLIC SMALL LETTER IE */
	{"e:", "ё"},	/* ё = CYRILLIC SMALL LETTER IO */
	{"e>", "є"},	/* є = CYRILLIC SMALL LETTER UKRAINIAN IE */
	{"z<", "ж"},	/* ж = CYRILLIC SMALL LETTER ZHE */
	{"z", "з"},	/* з = CYRILLIC SMALL LETTER ZE */
	{"z>", "ѕ"},	/* ѕ = CYRILLIC SMALL LETTER DZE */
	{"i", "и"},	/* и = CYRILLIC SMALL LETTER I */
	{"i`", "і"},	/* і = CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I */
	{"i:", "ї"},	/* ї = CYRILLIC SMALL LETTER YI */
	{"j<", "ј"},	/* ј = CYRILLIC SMALL LETTER JE */
	{"j", "й"},	/* й = CYRILLIC SMALL LETTER SHORT I */
	{"k", "к"},	/* к = CYRILLIC SMALL LETTER KA */
	{"l", "л"},	/* л = CYRILLIC SMALL LETTER EL */
	{"l>", "љ"},	/* љ = CYRILLIC SMALL LETTER LJE */
	{"m", "м"},	/* м = CYRILLIC SMALL LETTER EM */
	{"n", "н"},	/* н = CYRILLIC SMALL LETTER EN */
	{"n>", "њ"},	/* њ = CYRILLIC SMALL LETTER NJE */
	{"o", "о"},	/* о = CYRILLIC SMALL LETTER O */
	{"p", "п"},	/* п = CYRILLIC SMALL LETTER PE */
	{"r", "р"},	/* р = CYRILLIC SMALL LETTER ER */
	{"s", "с"},	/* с = CYRILLIC SMALL LETTER ES */
	{"t", "т"},	/* т = CYRILLIC SMALL LETTER TE */
	{"c'", "ћ"},	/* ћ = CYRILLIC SMALL LETTER TSHE */
	{"k'", "ќ"},	/* ќ = CYRILLIC SMALL LETTER KJE */
	{"u", "у"},	/* у = CYRILLIC SMALL LETTER U */
	{"u<", "ў"},	/* ў = CYRILLIC SMALL LETTER SHORT U */
	{"f", "ф"},	/* ф = CYRILLIC SMALL LETTER EF */
	{"h", "х"},	/* х = CYRILLIC SMALL LETTER HA */
	{"c", "ц"},	/* ц = CYRILLIC SMALL LETTER TSE */
	{"c<", "ч"},	/* ч = CYRILLIC SMALL LETTER CHE */
	{"d>", "џ"},	/* џ = CYRILLIC SMALL LETTER DZHE */
	{"s<", "ш"},	/* ш = CYRILLIC SMALL LETTER SHA */
	{"s>", "щ"},	/* щ = CYRILLIC SMALL LETTER SCHCHA */
	{"''", "ъ"},	/* ъ = CYRILLIC SMALL LETTER HARD SIGN */
	{"y", "ы"},	/* ы = CYRILLIC SMALL LETTER YERU */
	{"'", "ь"},	/* ь = CYRILLIC SMALL LETTER SOFT SIGN */
	{"e`", "э"},	/* э = CYRILLIC SMALL LETTER E */
	{"u>", "ю"},	/* ю = CYRILLIC SMALL LETTER YU */
	{"a>", "я"},	/* я = CYRILLIC SMALL LETTER YA */
	{"G`", "Ґ"},	/* Ґ = CYRILLIC CAPITAL LETTER GHE WITH UPTURN */
	{"g`", "ґ"},	/* ґ = CYRILLIC SMALL LETTER GHE WITH UPTURN */
	{"E<", "Ѣ"},	/* Ѣ = CYRILLIC CAPITAL LETTER YAT */
	{"e<", "ѣ"},	/* ѣ = CYRILLIC SMALL LETTER YAT */
	{"A<", "Ѫ"},	/* Ѫ = CYRILLIC CAPITAL LETTER BIG YUS */
	{"a<", "ѫ"},	/* ѫ = CYRILLIC SMALL LETTER BIG YUS */
	{"F`", "Ѳ"},	/* Ѳ = CYRILLIC CAPITAL LETTER FITA */
	{"f`", "ѳ"},	/* ѳ = CYRILLIC SMALL LETTER FITA */
	{"Y`", "Ѵ"},	/* Ѵ = CYRILLIC CAPITAL LETTER IZHITSA */
	{"y`", "ѵ"},	/* ѵ = CYRILLIC SMALL LETTER IZHITSA */
	{NIL_PTR}
};


/*======================================================================*\
|*				End					*|
\*======================================================================*/
